
/******************************************************************************
* MODULE     : glue.gen.cc
* DESCRIPTION: Glue for linking TeXmacs commands to guile
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef GLUE_HH
#define GLUE_HH
#include <guile/gh.h>
#include "tree.hh"
#include "widget.hh"
#include "Widget/make_widget.hh"

void initialize_glue ();
string scm_to_string (SCM p);
scheme_tree scm_to_scheme_tree (SCM p);
widget scm_to_widget (SCM widget_smob);
make_widget make_scheme_make_widget (scheme_tree p);

extern long widget_tag;
#define scm_is_widget(t) \
  (SCM_NIMP (t) && (((long) SCM_CAR (t)) == widget_tag))

class make_scheme_widget_rep: public make_widget_rep {
  // use "the_server" for scheme evaluation
  scheme_tree p;
public:
  make_scheme_widget_rep (scheme_tree p2): p(p2) {}
  ostream& print (ostream& out) { return out << p; }
  widget get_widget (display dis);
};

#endif // defined GLUE_HH
